# -*- coding: utf-8 -*-
#
#Copyright (C) 2010, Yader Velasquez
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.

from time import localtime, strftime, mktime
from datetime import datetime, date
from gettext import gettext as _

class FechaUnix(object):
    '''for get, convert and return dates based on the unix date'''

    def __init__(self, lista):
        '''init class'''
        self.fecha = datetime(lista[0], lista[1] + 1, lista[2]) 

    def fecha_unix(self):
        '''return a string of the actual date in unix format'''
        self.fecha_unix = mktime(self.fecha.timetuple()) 
        self.fecha_unix = int(self.fecha_unix)
        return str(self.fecha_unix)

    def indice_unix(self, fecha_unix):
        '''return a string to be use it like
        a index'''
        self.fecha_unix = fecha_unix
        self.fecha_unix = int(self.fecha_unix) 
        return strftime("%y%m%d", localtime(self.fecha_unix))
    
class FechaNormal(object):
    '''Get, convert and return dates in our popular format'''
    def __init__(self):
        '''init of FechaNormal'''
        self.fecha = datetime.today()

    def fecha_actual(self):
        '''return the actual date such as 
        day of month of year'''
        return self.fecha.strftime("%d de %B de %Y")
    
    def fecha_especial(self):
        '''special format of a date for 
        be use it like a dicctionary key 
        in the format day/month/year'''
        return self.fecha.strftime("%d/%m/%y")

    def numero_semana(self):
        '''return the number of the current week'''
        self.esta_semana = date.today()
        self.semana = date.isocalendar(self.esta_semana)
        return str(self.semana[1])
